#include "bloc.h"

#include <SDL/SDL.h>

#include <algorithm>
using namespace std;

// ----------------------------------------------------
Bloc::Bloc( int c, int s, const char* tab ) : color_( c ), size_( s )
{
  for ( ; *tab; ++tab )
    data_.push_back( (*tab=='X')?1:0 );
}

// ----------------------------------------------------
void Bloc::rotationRight()
{
    for ( int i = 0; i < size() / 2 ; ++i )
        for ( int j = 0; j < ( size() + 1 )/ 2; ++j )
        {
          int iAux = size() - 1 - i;
          int jAux = size() - 1 - j;
          swap( data_[i * size() + j], data_[jAux * size() + i] );
          swap( data_[i * size() + j], data_[iAux * size() + jAux] );
          swap( data_[i * size() + j], data_[j * size() + iAux] );
        }
}

// ----------------------------------------------------
void Bloc::rotationLeft()
{
    for ( int i = 0; i < size() / 2 ; ++i )
        for ( int j = 0; j < ( size() + 1 )/ 2; ++j )
        {
          int iAux = size() - 1 - i;
          int jAux = size() - 1 - j;
          swap( data_[i * size() + j], data_[j * size() + iAux] );
          swap( data_[i * size() + j], data_[iAux * size() + jAux] );
          swap( data_[i * size() + j], data_[jAux * size() + i] );
        }
}

// ----------------------------------------------------
void Bloc::display( SDL_Surface* screen, SDL_Surface* tuiles, int x, int y ) const
{
  for ( int i = 0; i < size(); ++i )
    for ( int j = 0; j < size(); ++j )
      if ( get( i, j ) )
      {
        SDL_Rect rectDest;
        rectDest.x = i * 20 + x * 20;
        rectDest.y = j * 20 + (y+1) * 20;
        rectDest.w = rectDest.h = 0;

        SDL_Rect rectSrc;
        rectSrc.x = color() * 20;
        rectSrc.y = 0;
        rectSrc.w = rectSrc.h = 20;

        SDL_BlitSurface( tuiles, &rectSrc, screen, &rectDest );
      }
}
